/*
* Copyright (c) 2022 TECNALIA RESEARCH & INNOVATION.
* All rights reserved. This program and the accompanying materials
* are made available under the terms of Affero General Public License (AGPL) version 3
* which accompanies this distribution, and is available at

* https://www.gnu.org/licenses/agpl-3.0.en.html
*
* Contributors:
*
* Gonzalo Lazaro, Jose Manuel Rio, Alejandro Rodriguez, Sonia Bilbao from Tecnalia
*
* Initially developed in the context of URBANITE EU project
* www.urbanite-project.eu
*/
package com.tecnalia.urbanite.anonymize;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.autoconfigure.data.mongo.MongoDataAutoConfiguration;
import org.springframework.boot.autoconfigure.mongo.MongoAutoConfiguration;
import org.springframework.context.annotation.Bean;

import io.swagger.v3.oas.models.OpenAPI;
import io.swagger.v3.oas.models.info.Info;
import io.swagger.v3.oas.models.servers.Server;
//import io.swagger.v3.oas.models.info.Contact;
//import io.swagger.v3.oas.models.info.License;
//import io.swagger.v3.oas.models.ExternalDocumentation;

@SpringBootApplication(exclude = {MongoAutoConfiguration.class, MongoDataAutoConfiguration.class})
public class AnonymizeApplication {

	public static void main(String[] args) {
		SpringApplication.run(AnonymizeApplication.class, args);
	}

	@Bean
    public OpenAPI customOpenAPI(@Value("${application-description}") String appDesciption, @Value("${application-version}") String appVersion) {
	 return new OpenAPI()
			 .addServersItem(new Server().url("/anonymize/"))
			 .info(new Info()
        		  .title("Anonymize API")
        		  .version(appVersion)
        		  .description(appDesciption)
        		  //.contact(new Contact().email("info@tecnalia.com").name("Tecnalia").url("tecnalia.com"))
        		  //.termsOfService("http://swagger.io/terms/")
        		  //.license(new License().name("Apache 2.0").url("http://springdoc.org"))
        		  )
          //.externalDocs(new ExternalDocumentation().description("Data Model Explanation").url("/data/datamodel.html"))
          ;
    }
}
