package com.tecnalia.urbanite.anonymize.service;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URLEncoder;
import java.net.http.HttpClient;
import java.net.http.HttpRequest;
import java.net.http.HttpResponse;
import java.net.http.HttpResponse.BodyHandlers;
import java.nio.charset.StandardCharsets;

import org.codehaus.jettison.json.JSONArray;
import org.codehaus.jettison.json.JSONException;
import org.codehaus.jettison.json.JSONObject;
import org.springframework.stereotype.Service;

import com.tecnalia.urbanite.anonymize.utils.Configuration;

@Service
public class DataService {
	
	public JSONArray getObjectsByName(String property, String value, String model, String city) throws JSONException, URISyntaxException, IOException, InterruptedException {
		String URL =  Configuration.getExporterUrl();
		//String filter =  "%7B%22name%22%3A%20%22"+name+"%22%7D";
		String filter =  encode("{\""+property+"\":\""+value+"\"}");
		
		//https://bilbao.urbanite.esilab.org/data/getTData/mapLayer/bilbao?filters=%7B%22alternateName%22%3A%20%22test.geojson%22%7D
		System.out.println("URL:"+URL+"/data/getTData/"+model+"/"+city+"?filters="+filter+"&sort=ASC");
		HttpRequest request = HttpRequest.newBuilder()
				  .uri(new URI(URL+"/data/getTData/"+model+"/"+city+"?filters="+filter+"&sort=ASC"))
				  .GET()
				  .build();
		
		HttpResponse<String> response = HttpClient
				  .newBuilder()
				  .build()
				  .send(request, BodyHandlers.ofString());
		return  new JSONArray(response.body());		
	}

	public JSONObject updateObjects(JSONObject name, String model, String city, String id) throws JSONException, URISyntaxException, IOException, InterruptedException {
		String URL =  Configuration.getExporterUrl();
		System.out.println("URL:"+URL+"/data/updateTData/"+model+"/"+city+"/"+id);
		HttpRequest request = HttpRequest.newBuilder()
				  .uri(new URI(URL+"/data/updateTData/"+model+"/"+city+"/"+id))
				  .PUT(HttpRequest.BodyPublishers.ofString(name.toString()))
				  .setHeader("Content-Type", "application/json")
				  .build();
		
		HttpResponse<String> response = HttpClient
				  .newBuilder()
				  .build()
				  .send(request, BodyHandlers.ofString());		
		return  new JSONObject(response.body());		
	}
	
	public JSONObject deleteObject(String model, String city, String id) throws JSONException, URISyntaxException, IOException, InterruptedException {
		String URL =  Configuration.getExporterUrl();
		System.out.println("URL:"+URL+"/data/deleteTData/"+model+"/"+city+"/"+id);
		HttpRequest request = HttpRequest.newBuilder()
				  .uri(new URI(URL+"/data/deleteTData/"+model+"/"+city+"/"+id))
				  .PUT(HttpRequest.BodyPublishers.noBody())
				  //.setHeader("Content-Type", "application/json")
				  .build();
		
		HttpResponse<String> response = HttpClient
				  .newBuilder()
				  .build()
				  .send(request, BodyHandlers.ofString());
		System.out.println(response.body());
		return  new JSONObject(response.body());		
	}	
	public JSONObject getDistinctObject(String model, String city, String field) throws JSONException, URISyntaxException, IOException, InterruptedException {
		String URL =  Configuration.getExporterUrl();
		
		System.out.println("URL:"+URL+"/data/getDistinct/"+model+"/"+city+"?field="+field);
		HttpRequest request = HttpRequest.newBuilder()
				  .uri(new URI(URL+"/data/getDistinct/"+model+"/"+city+"?field="+field))
				  .GET()				  
				  .build();
		
		HttpResponse<String> response = HttpClient
				  .newBuilder()
				  .build()
				  .send(request, BodyHandlers.ofString());
		System.out.println(response.body());
		return  new JSONObject(response.body());		
	}	
	
	
	private String encode(String value) throws UnsupportedEncodingException {
		
	    return URLEncoder.encode(value, StandardCharsets.UTF_8.toString());
	}
}
