
package sml.geoUtils;

import sml.geoUtils.geometry.IPointGeo;

public class GreatCircleDistanceCalculator implements IDistanceCalculator {
      Double EARTH_RADIOUS = 6371010.0;
      public Double calculate2D(IPointGeo pt1, IPointGeo pt2)  {
          //System.out.println("GreateCircleDistanceCalculator.calculate2D:::in routine");
          Double dLat = Calculations.toRadians(pt2.getLatitude()-pt1.getLatitude());
          Double dLon = Calculations.toRadians(pt2.getLongitude()-pt1.getLongitude());
          Double a = Math.sin(dLat/2.0) * Math.sin(dLat/2.0) 
                   + Math.cos(Calculations.toRadians(pt1.getLatitude())) * 
                     Math.cos(Calculations.toRadians(pt2.getLatitude())) * 
                     Math.sin(dLon/2.0) * Math.sin(dLon/2.0);
          Double dAngle = 2 * Math.asin(Math.sqrt(a));
          return dAngle * this.EARTH_RADIOUS;
                  
      
      }
}
