
package sml.geoUtils;

import sml.geoUtils.geometry.IPointGeo;
import sml.geoUtils.geometry.PointGeo;

public class Vector3 {
         Double x;
         Double y;
         Double z;
         public Double getX(){ return x; }
         public Double getY(){ return y; }
         public Double getZ(){ return z; }
         public void setX(Double x){ this.x = x; }
         public void setY(Double y){ this.y = y; }
         public void setZ(Double z){ this.z = z; }
         public Vector3(){}
         public Vector3(IPointGeo sphericalPoint){
             Double lat = Math.PI / 2.0 - Calculations.toRadians(sphericalPoint.getLatitude());
             Double lon = Calculations.toRadians(sphericalPoint.getLongitude());
             this.x = Math.sin(lat) * Math.cos(lon);
             this.y = Math.sin(lat) * Math.sin(lon);
             this.z = Math.cos(lat);
         }
         public void normalize(){
             Double length = Math.sqrt(this.x * this.x + this.y * this.y + this.z * this.z);
             this.x = this.x/length;
             this.y = this.y/length;
             this.z = this.z/length;
         }
         public void multiply(Double factor){
            this.x = this.x * factor;
            this.y = this.y * factor;
            this.z = this.z * factor;
         }
         public PointGeo toSpherical(){
            PointGeo result = new PointGeo();
            result.setLatitude(Calculations.toDegrees(Math.PI/2.0 - Math.acos(this.z)));
            result.setLongitude(Calculations.toDegrees(Math.atan2(this.y, this.x)));
            return result;
         }
         public static Vector3 crossProduct(Vector3 A, Vector3 B){
            Vector3 crossProd = new Vector3();
            crossProd.setX(A.getY() * B.getZ() - A.getZ() * B.getY());
            crossProd.setY(A.getZ() * B.getX() - A.getX() * B.getZ());
            crossProd.setZ(A.getX() * B.getY() - A.getY() * B.getX());
            return crossProd;                  
         } 
}
