
package sml.geoUtils.geometry;

import java.util.ArrayList;
import sml.geoUtils.Calculations;
import sml.gps.datamodel.GPSPoint;


public class Polyline<T extends IPointGeo> implements IPolyline<T> {

    ArrayList<Segment<T>> segments;
    ArrayList<T>          nodes;
    Double                length;
    public Polyline(){
        this.nodes = new ArrayList<T>();
        //this.nodes.
        this.invalidateComputedProperties(null);
    
    }
    private void invalidateComputedProperties(Object sender){
        this.length = Double.NaN;
        this.segments = null;
    }

    public Double getLength(){
        if (Double.isNaN(this.length)){
            this.length = Calculations.getLength((IPolyline<IPointGeo>)this);
        }
        Double dist = 0.0;
        if ( this.nodes.size() > 1 ){
            T oldNode = this.nodes.get(0);
            for(int i=1;i<this.nodes.size();i++){
                T node = this.nodes.get(i); 
                //System.out.println("\t\t i="+i+" node="+this.nodes.get(i).getLatitude()+","+this.nodes.get(i).getLongitude());
                dist = dist + Calculations.getDistance2D(oldNode,node);
                oldNode = node;
            }
        }
        this.length = dist/1000.0;
        return this.length;
    }
    public int getNodeCount(){
        return this.nodes.size();
    }
    public ArrayList<Segment<T>> getSegments(){
        ArrayList<Segment<T>> result = new ArrayList<Segment<T>>();
        boolean ltrace = true;
        if ( false ){
            System.out.println("# nodes="+this.nodes.size());
            for(int i=0; i < this.nodes.size()-1;i++){
                System.out.println("about to create segment from <"+this.nodes.get(i).getLatitude()+","+this.nodes.get(i).getLongitude()+
                                                    "> -- <"+this.nodes.get(i+1).getLatitude()+","+this.nodes.get(i+1).getLongitude()+">");
            }
        }
        for(int i=0; i < this.nodes.size()-1;i++){
            result.add(new Segment<T>(this.nodes.get(i), this.nodes.get(i+1)));
        }
        return result;
    }
    public ArrayList<T> getNodes() {
        return this.nodes;
    }
    public void setNodes(ArrayList<T> newNodes){
        this.nodes = newNodes;
    }
}
