
package sml.geoUtils.geometry;

import sml.geoUtils.Calculations;

public class Segment<T extends IPointGeo> {
    T startPoint;
    T endPoint;
    Double length;
    public Segment(T start, T end){
        this.startPoint = start;
        this.endPoint   = end;
        this.length     = Calculations.getDistance2D(this.startPoint,this.endPoint);
    }
    public T getStartPoint(){
       return this.startPoint;
    }
    private void setStartPoint(T startPoint){
       this.startPoint = startPoint;
    }
    public T getEndPoint(){
       return this.endPoint;
    }
    private void setEndPoint(T endPoint){
       this.endPoint = endPoint;
    }
    public Double getLength(){
       return this.length;
    }
    public boolean equals(Object obj){
         boolean result = false;
         Segment<T> other = (Segment<T>)obj;
         if (other != null){
             result = this.startPoint.equals(other.startPoint) && this.endPoint.equals(other.endPoint);
         }
         
         return result;
    }
}
