package sml.utils;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;


public class RawData {
   private ArrayList<ArrayList<Double>> APos    = new ArrayList<ArrayList<Double>>();
   private ArrayList<Long>              ATimes  = new ArrayList<Long>();
   private ArrayList<Double>            AVels   = new ArrayList<Double>();
   private File file;
   
   public RawData(File file)                             {
        this.file = file;
        readData();
   }
   private void                        readData() {
      BufferedReader br         = null;
      String         line       = "";
      String         cvsSplitBy = ",";
      try {
            br = new BufferedReader(new FileReader(this.file.getAbsolutePath()));
            int k=0;

            while ((line = br.readLine()) != null) {
                String[] lineText = line.split(cvsSplitBy);
                this.ATimes.add(Long.parseLong(lineText[0])/1000);
                Double vel = -1.0;
                if ( lineText.length > 2 ){
                   if (!"".equals(lineText[3]) || lineText[3] != null){
                      vel = Double.parseDouble(lineText[3]);
                   }
                }
                AVels.add(vel);
                ArrayList<Double> Node = new ArrayList<Double>();
                Node.add(Double.parseDouble(lineText[1]));
                Node.add(Double.parseDouble(lineText[2]));
                this.APos.add(Node);
                k++;
            }
         
      } catch (IOException ex) {
            System.out.println("problem accessing file"+this.file.getAbsolutePath());
      }
   }
   public File                         getFile()  {return this.file;}
   public int                          getSize()  {return this.APos.size();}
   public ArrayList<ArrayList<Double>> getAPos()  {return this.APos;}
   public ArrayList<Long>              getATimes(){return this.ATimes;}
   public ArrayList<Double>            getAVels() {return this.AVels;}
}
