package sml.visualizer.gui.functions;

import java.util.ArrayList;
import sml.gps.datamodel.GPSPoint;
import sml.gps.datamodel.GPSRoute;
import sml.stops.datamodel.StopData;

public class DivideInTraysCover {
    
   private GPSRoute route;
   private final static String PRETEXT = "sml.visualizer.gui.functions.DivideInTraysCover";

   public DivideInTraysCover(GPSRoute route){
        this.route = route;
        //doFindingTrays();
   }
   public ArrayList<GPSRoute> doFindingTrays(){
       ArrayList<GPSRoute> out = new ArrayList<>();
  
        double maxSpread = 0.2;
        double minTime   = 10;
        double maxVel    = 2.0;
        int    numPoints = 4;
        double randWalk  = 0.02;
        FindStops fs = new FindStops(maxSpread,minTime,maxVel,numPoints,randWalk);         
        fs.addRawData(route);
        ArrayList<StopData> stops = fs.doStops();
        ArrayList<Long> iniStops = new ArrayList<>();
        ArrayList<Long> endStops = new ArrayList<>();
        for(int s=0;s<stops.size();s++){
           iniStops.add(stops.get(s).getIniTime());
           endStops.add(stops.get(s).getEndTime());
           System.out.println(PRETEXT+".doFindingTrays::: CDR stop="+s+" ["+stops.get(s).getIniTime()+","+stops.get(s).getEndTime()+"]");
        }
        iniStops.add(Long.MAX_VALUE);
        endStops.add(Long.MAX_VALUE);
        int s = 0;
        GPSRoute routeTray = null;
        
        Long time;
        boolean inStop = false;
        time = route.getNodes().get(0).getTime();
        if ( time < iniStops.get(s) ){
               routeTray = new GPSRoute();
               routeTray.setName(route.getName()+"_tray_-1");
              
        }
        for(int p=0;p<route.getNodeCount();p++){
           time = route.getNodes().get(p).getTime();
           if ( time >= iniStops.get(s) && time < endStops.get(s) ){
               inStop = true;
           }
           else if ( time >= endStops.get(s) ){
               routeTray = new GPSRoute();
               routeTray.setName(route.getName()+"_tray_"+s);
               out.add(routeTray);
             
               s++;   
               inStop = false;
           }
           if ( !inStop ){
              GPSPoint pnt = route.getNodes().get(p);
              routeTray.getNodes().add(pnt);
             
           }
        }
      
       return out;
    }
}
